cgRequests = [];
jQuery(document).ready(function($){

    cgLoadGallery();

    var cgChangedAndSearchedValueSelector = cgJsAdminClass.vars.cgChangedAndSearchedValueSelector;

    function cgAbortRequests(){

        for(var index in cgRequests){
            cgRequests[index].abort();
            delete cgRequests[index];
        }
    }

    // show cg-info

    $(document).on('mouseenter','.cg_backend_info_container.cg_searched_value',function () {

        $(this).parent().find('.cg-info-container').show();

    });

    $(document).on('mouseleave','.cg_backend_info_container.cg_searched_value',function () {

        $(this).parent().find('.cg-info-container').hide();

    });


    // send only values that are needed to send
    $(document).on('change',cgChangedAndSearchedValueSelector,function () {
        $(this).addClass('cg_value_changed');
    });


    $(document).on('click','#cgPicsPerSite .cg_step',function (e) {
        e.preventDefault();
        cgAbortRequests();

        $('#cgPicsPerSite .cg_step').removeClass('cg_step_selected');

        // have to start from 0 again then
        $('#cgStepsChanged').prop('disabled',false);

        cgChangeViewByControl($(this).addClass('cg_step_selected'));

    });

    $(document).on('click','.cg_steps_navigation .cg_step',function (e) {
        e.preventDefault();
        cgAbortRequests();

        cgChangeViewByControl(null,$(this));

        if($(this).closest('.cg_steps_navigation').attr('id')=='cgStepsNavigationBottom'){
            document.getElementById('cgGalleryForm').scrollIntoView();
        }

    });

    $(document).on('change','#cgOrderSelect',function () {
        cgAbortRequests();

        var $selected = $(this).find(':selected');
        $('#cgOrderValue').val($selected.val());

        cgChangeViewByControl();

    });

    $(document).on('input','#cgSearchInput',function () {

        cgAbortRequests();
        var $el = $(this);
        $el.val($el.val().trim());
        $('#cgStartValue').val('0');
        if($el.val().length>=1){
            $el.addClass('cg_searched_value');
            $('#cgSearchInputClose').removeClass('cg_hide');
        }else{
            $el.removeClass('cg_searched_value');
            $('#cgSearchInputClose').addClass('cg_hide');
        }

        cgChangeViewByControl(null,null,null,true);

    });

    $(document).on('submit','#cgGalleryForm',function (e) {
        e.preventDefault();
        cgAbortRequests();
        // disable all fields which were not changed!!!!
        $(cgChangedAndSearchedValueSelector).not(".cg_value_changed").prop('disabled',true);
        cgChangeViewByControl(null,null,true);
    });

    $(document).on('click','#cgSearchInputClose',function (e) {
        e.preventDefault();
        cgAbortRequests();

        var $cgSearchInput = $('#cgSearchInput');

        $cgSearchInput.removeClass('cg_searched_value');

        $(this).addClass('cg_hide');

        $cgSearchInput.val('');

        localStorage.setItem('cgSearch_BG_'+gid, '');
        cgChangeViewByControl();
    });

    function cgMarkSearchedValueFields() {

        var $cgSearchInput = $('#cgSearchInput');
        var cgSearchInputValue = $cgSearchInput.val();
        if(cgSearchInputValue.length>=1){
            $('#cgSearchInputClose').removeClass('cg_hide');
            var cgSearchedValueHiddenFieldsSelector = '#cgSortable .cg_wp_user_display_name,#cgSortable .cg_wp_user_email,#cgSortable .cg_wp_user_nicename,#cgSortable .cg_wp_user_login,' +
                '#cgSortable .cg_wp_post_content, #cgSortable .cg_wp_post_name, #cgSortable .cg_wp_post_title, #cgSortable .cg_image_id';
            var $inputFieldsWithValue = $(cgChangedAndSearchedValueSelector).filter(function () {return $(this).val().toLowerCase().indexOf(cgSearchInputValue.toLowerCase()) != -1; });
            var $inputHiddenFieldsWithValue = $(cgSearchedValueHiddenFieldsSelector).filter(function () {return $(this).val().toLowerCase().indexOf(cgSearchInputValue.toLowerCase()) != -1; });
            $cgSearchInput.addClass('cg_searched_value');
            $inputHiddenFieldsWithValue.closest('.cg_backend_info_container').addClass('cg_searched_value');
            $inputFieldsWithValue.addClass('cg_searched_value');

            var $cgCategorySelects = $('#cgSortable .cg_category_select option').filter(function () { return $(this).html().toLowerCase() === cgSearchInputValue.toLowerCase(); }).closest('.cg_category_select');
            $cgCategorySelects.addClass('cg_searched_value');

            $('#cgStepsNavigationTop .cg_step, #cgStepsNavigationBottom .cg_step').not('.cg_step_selected').addClass('cg_searched_value');
        }

        var $cgOrderSelect = $('#cgOrderSelect');
        var cgOrderSelectValue = $cgOrderSelect.val();
        if(cgOrderSelectValue!='date_desc'){
            $cgOrderSelect.addClass('cg_searched_value');
        }else{
            $cgOrderSelect.removeClass('cg_searched_value');
        }

    }

    function cgMissingRights(response){
        if(response.indexOf('MISSINGRIGHTS')>=0){
            response = response.split('MISSINGRIGHTS')[1];
            var htmlDom = $.parseHTML(response);
            $(htmlDom).insertAfter(jQuery('#cgViewControl'));
            $('#cgGalleryLoader').addClass('cg_hide');
            return true;
        }else{
            return false;
        }
    }

    function checkIfFurtherImagesAvailable(){

        $('#chooseAction1').val(1); //!Important to do it here, otherwise will try to delete pics again!!!
        if($('#cgStepsNavigationTop .cg_step').length){// happens when images in last step were deleted!!!
            $('#cgStepsNavigationTop .cg_step:last-child').click();
        }

    }

    function cgLoadGallery() {

        if($('#cgIsNewGalleryCreated').length){
            return;
        }

        $('#chooseAll').prop('checked',false);

        var gid = $('#cgBackendGalleryId').val();

        // BG is for backend gallery
        var cgStart_BG = localStorage.getItem('cgStart_BG_'+gid);
        // check types also here because can be 0
        if(cgStart_BG || cgStart_BG===0 || cgStart_BG==='0'){$('#cgStartValue').val(cgStart_BG)}
        var cgStep_BG = localStorage.getItem('cgStep_BG_'+gid);
        if(cgStep_BG){$('#cgStepValue').val(cgStep_BG)}
        var cgOrder_BG = localStorage.getItem('cgOrder_BG_'+gid);
        if(cgOrder_BG){$('#cgOrderValue').val(cgOrder_BG)}
        var cgSearch_BG = localStorage.getItem('cgSearch_BG_'+gid);
        if(cgSearch_BG){$('#cgSearchInput').val(cgSearch_BG)}

        var form = document.getElementById('cgGalleryForm');
        var formPostData = new FormData(form);

        // AJAX Call - Submit Form
        cgRequests.push($.ajax({
            url: 'admin-ajax.php',
            method: 'post',
            data: formPostData,
            dataType: null,
            contentType: false,
            processData: false
        }).done(function(response) {

            if(cgMissingRights(response)){return;}

            $('#cgGalleryLoader').addClass('cg_hide');

            var htmlDom = new DOMParser().parseFromString(response, 'text/html');
            var $cgSortable = $(htmlDom.getElementById('cgSortable'));
            var $cgGallerySubmit = $(htmlDom.getElementById('cgGallerySubmit'));
            var $cgStepsNavigationTop = $(htmlDom.getElementById('cgStepsNavigationTop'));
            var $cgStepsNavigationBottom = $(htmlDom.getElementById('cgStepsNavigationBottom'));

            $cgStepsNavigationTop.insertAfter($('#cgGalleryLoader'));
            $cgSortable.insertAfter($cgStepsNavigationTop);

            var isNoImagesFound = false;

            if($cgSortable.find('.cg_backend_info_container').length>=1){
                $cgGallerySubmit.insertAfter($cgSortable);
                $cgSortable.find('#cgNoImagesFound').addClass('cg_hide');
            }else{
                isNoImagesFound = true;
                $cgSortable.find('#cgNoImagesFound').removeClass('cg_hide');
            }

            $cgStepsNavigationBottom.insertAfter($cgGallerySubmit);

            cgMarkSearchedValueFields();

            $('#cgStepsChanged').prop('disabled',true);

            cgSortableInit();

            if(isNoImagesFound){
                checkIfFurtherImagesAvailable();
            }

        }).fail(function(xhr, status, error) {


        }).always(function() {

        }));

    }

    function cgChangeViewByControl($cgStep,$cgStart,isFormSubmit,isInput) {
        $('#chooseAll').prop('checked',false);

        if($cgStep){
            $('#cgStepValue').val($cgStep.attr('data-cg-step-value'));
        }
        //console.log($('#cgStepsNavigationTop .cg_step.cg_step_selected').first().attr('data-cg-start'));
        //console.log($('#cgStepsNavigationTop .cg_step.cg_step_selected'));
        //debugger

        if($cgStart){
            $('#cgStartValue').val($cgStart.attr('data-cg-start'));
        }else{
            if(!isInput){
                $('#cgStartValue').val($('#cgStepsNavigationTop .cg_step.cg_step_selected').first().attr('data-cg-start'));
            }
        }

        var $cgGallerySubmit = $('#cgGallerySubmit').addClass('cg_hide');
        var $cgSortable = $('#cgSortable').addClass('cg_hide');
        var $cgGalleryLoader = $('#cgGalleryLoader').removeClass('cg_hide');
        var $cgStepsNavigationTop = $('#cgStepsNavigationTop').addClass('cg_hide');
        var $cgStepsNavigationBottom = $('#cgStepsNavigationBottom').addClass('cg_hide');

        if(isFormSubmit){
            $('#cgGalleryFormSubmit').prop('disabled',false);
        }

        var form = document.getElementById('cgGalleryForm');
        var formPostData = new FormData(form);

        var gid = $('#cgBackendGalleryId').val();

        // BG is for backend gallery
        localStorage.setItem('cgStart_BG_'+gid, $('#cgStartValue').val());
        localStorage.setItem('cgStep_BG_'+gid, $('#cgStepValue').val());
        localStorage.setItem('cgOrder_BG_'+gid, $('#cgOrderSelect').val());
        localStorage.setItem('cgSearch_BG_'+gid, $('#cgSearchInput').val());

        if(isFormSubmit){
            var scrollTop = $('#cgGalleryForm').offset().top-50;
            $(window).scrollTop(scrollTop);
        }

        // AJAX Call - Submit Form
        cgRequests.push($.ajax({
            url: 'admin-ajax.php',
            method: 'post',
            data: formPostData,
            dataType: null,
            contentType: false,
            processData: false
        }).done(function(response) {

            if(cgMissingRights(response)){return;}

            var htmlDom = new DOMParser().parseFromString(response, 'text/html');
            var DOM_cgSortable = htmlDom.getElementById('cgSortable');
            var DOM_cgGallerySubmit = htmlDom.getElementById('cgGallerySubmit');
            var DOM_cgStepsNavigationTop = htmlDom.getElementById('cgStepsNavigationTop');
            var DOM_cgStepsNavigationBottom = htmlDom.getElementById('cgStepsNavigationBottom');

            $cgGalleryLoader.addClass('cg_hide');

            $cgStepsNavigationTop.get(0).replaceWith(DOM_cgStepsNavigationTop);
            $(DOM_cgStepsNavigationTop).removeClass('cg_hide');
            $cgSortable.get(0).replaceWith(DOM_cgSortable);
            $(DOM_cgSortable).removeClass('cg_hide');

            var isNoImagesFound = false;

            // new cg sortable has to taken for search!!!
            if($(DOM_cgSortable).find('.cg_backend_info_container').length>=1){
                $cgGallerySubmit.replaceWith(DOM_cgGallerySubmit);
                $(DOM_cgGallerySubmit).removeClass('cg_hide');
                $cgSortable.find('#cgNoImagesFound').addClass('cg_hide');
            }else{
                isNoImagesFound = true;
                $(DOM_cgSortable).find('#cgNoImagesFound').removeClass('cg_hide');
            }

            if($cgStepsNavigationBottom.length){
                $cgStepsNavigationBottom.get(0).replaceWith(DOM_cgStepsNavigationBottom);
                $(DOM_cgStepsNavigationBottom).removeClass('cg_hide');
            }

            cgMarkSearchedValueFields();

            if(isFormSubmit){
                $("#cg_changes_saved").fadeOut(4000);
            }else{
                $("#cg_changes_saved").remove();
            }

            $('#cgStepsChanged').prop('disabled',true);

            cgSortableInit();

            if(isNoImagesFound){
                checkIfFurtherImagesAvailable();
            }

        }).fail(function(xhr, status, error) {


        }).always(function() {

        }));


    }

    function cgSortableInit() {

        //Sortieren der Galerie


        var $i = 0;

        var rowid = [];

        if($i==0){

            $( ".cgSortableDiv" ).each(function( i ) {

                var rowidValue =  $(this).find('.rowId').val();


                rowid.push(rowidValue);

            });

            $i++;

        }


        $(function() {
            $( "#cgSortable" ).sortable({cursor: "move",handle:'.cg_drag_area',placeholder: "ui-state-highlight",
                stop: function( event, ui ) {

                    if(document.readyState === "complete"){

                        var v = 0;

                        $( ".cgSortableDiv" ).each(function( i ) {


                            $(this).find('.rowId').val(rowid[v]).addClass('cg_value_changed');


                            v++;


                        });

                        v = 0;

                    }

                },
                start: function( event, ui){

                    var $element = $(ui.item);

                    $element.closest('#cgSortable').find('.ui-state-highlight').addClass($element.get(0).classList.value).html($element.html());

                }
            });
        });


        //Sortieren der Galerie --- ENDE

    }

});